/**************************************************************/
/***************  IMAGE MANAGER  a.d. 1996  ******************/
/**************************************************************/
/***************        Martin Hejral        ******************/
/**************************************************************/

#include <aes.h>
#include <vdi.h>

#include "imghead.h"
#include "imgproc.h"

/* ---------------------------------------------------------- */
/*       Funktionsprototypen                                  */
/* ---------------------------------------------------------- */

void open_window( void );
int  rc_intersect( GRECT *r1, GRECT *r2 );
void redraw_window( int all );
int  handle_message( int mbuf[8] );
void event_loop( void );

void show_params(IMAGE *im);
void my_init(void);
void end(void);
void load(void);
void play_seq(void);

/* -------------------------------------------------------- */
/*       macros                                             */
/* -------------------------------------------------------- */

#define abs(x) ((x)<0 ? -(x):(x))
#define pf printf
#define mem(a) malloc(sizeof(a))

/* AES macros */
#define dialog(s) rsrc_gaddr(R_TREE,(s),&m); form_center(m,&x,&y,&w,&h); form_dial(1,2,2,1,1,x,y,w,h); objc_draw(m,0,8,x,y,w+9,h+9)
#define undial(s) form_dial(3,2,2,1,1,x,y,w,h)
#define mouse(a,b,c) evnt_button((a),(b),(c),&mx,&my,&mb,&ks)
#define showm graf_mouse( M_ON, (void *)0 )
#define hidem graf_mouse( M_OFF, (void *)0 )
#define setm(x) graf_mouse((x),0)

/* VDI macros */
#define triangle(xy) v_fillarea(handle,3,(xy))
#define pbox(xy) v_fillarea(handle,4,(xy))
#define line(a,b,c,d) xy[0]=a; xy[1]=b; xy[2]=c; xy[3]=d; v_pline(handle,2,xy)
#define box(a,b,c,d) draw_line(x1+(a),y1+(b),x1+(a),y1+(d)); draw_line(x1+(a),y1+(d),x1+(c),y1+(d)); draw_line(x1+(c),y1+(d),x1+(c),y1+(b)); draw_line(x1+(c),y1+(b),x1+(a),y1+(b))
#define circle(x,y,r) draw_circle(x1+(x),y1+(y),(r),1)
#define text(a,b,c,d) print_string(x1+(a),y1+(b),(c),(d))
#define mode set_fg_bp(1); set_ln_mask(0xFFFF); set_wrt_mode
#define color(a) vsf_color(handle,(a))		/* set fill color */

/* ------------------------------------------------------------ */
/*       Global Variables                                       */
/* ------------------------------------------------------------ */

extern int _app;                    /* das Programm feststellen, ob es  */
                                    /* als Accessory oder normale App-  */
                                    /* likation gestartet wurde.        */

int    whandle;                     /* Handle fr geffnetes Fenster.   */
char   title[] = __IMGLIB__;        /* Titelzeile des Fensters.         */
int    gl_wchar,                    /* Gre und Breite eines Buchsta-  */
       gl_hchar,                    /* ben (wichtig falls mit unter-    */
       gl_wbox,                     /* schiedlichen Bildschirmaufl-    */
       gl_hbox;                     /* sungen gearbeitet wird) bzw.     */
                                    /* einer Box.                       */
int    aes_handle,                 /* Handles fr AES und unsere VDI   */
       handle;                      /* Arbeitstation. */
int    appl_id,                     /* Identifikationsnummer des Prog.  */
       menu_id;                     /* Id.-nummer im Men 'Desk'.       */

int xy[32];    	/* pxyarray */
int mx,my,mb,ks;   	/* mouse status */



/* ########################################################## */
/* ########################################################## */
/* SPECIFIC APPLICATION'S global VARIABLES place here */
/* ########################################################## */
/* ########################################################## */



/* ---------------------------------------------------------- */
/*       void main( void );                                   */
/* ---------------------------------------------------------- */

int main( void )
{
	int i, work_in[11], work_out[57];

/* ########################################################## */
	my_init();		/* USER's SPECIFIC INIT */
/* ########################################################## */

	/***** initialize GEM *****/
	
	appl_id = appl_init();
	if( appl_id < 0 )  return -1;
	
	for( i = 0; i < 10; i++ ) work_in[i] = 1;
	work_in[10] = 2;
	aes_handle = graf_handle( &gl_wchar, &gl_hchar, &gl_wbox, &gl_hbox );
	handle = aes_handle;
	v_opnvwk( work_in, &handle, work_out );
	
/* ########################################################## */
	init_imglib();
	
	/* demonstration of IMAGE LIBRARY */
	v_clrwk(handle);
	play_seq();  load();  evnt_keybd();  restore_palette();
/* ########################################################## */
	
#ifdef D
printf("res%i,%i,%i(planes%i);handle%i;\n",xm,ym,cm,bitplanes,handle); evnt_keybd();
#endif
	
	if( !_app )	/* accessory OR aplication ? */
		menu_id = menu_register( appl_id, "  Image" );
	else
	{
	  graf_mouse( 0, (void*)0 );
	  open_window( );
	}

	/* main programm loop */
	event_loop();
	
	appl_exit( );	return 0;
} /* main() */



/* ---------------------------------------------------------- */
/*       void open_window( void );                            */
/* ---------------------------------------------------------- */

void open_window( void )
{
   if ( whandle <= 0 )
   {
      whandle = wind_create( NAME|CLOSER|MOVER, 0, 0, xm + 1, ym + 1 );
      if ( whandle <= 0 )
         return;

      wind_set( whandle, WF_NAME, title );
      wind_open( whandle, 0, 20, xm+1 , ym-19 );
	 }
   else
      wind_set( whandle, WF_TOP );

}



/* --------------------------------------------------------------- */
/*       boolean rc_intersect( GRECT *r1, GRECT *r2 );             */
/*                                                                 */
/*       Berechnung der Schnittflche zweier Rechtecke.            */
/*                                                                 */
/*       -> r1, r2               Pointer auf Rechteckstruktur.     */
/*                                                                 */
/*       <-                      == 0  falls sich die Rechtecke    */
/*                                     nicht schneiden,            */
/*                               != 0  sonst.                      */
/* --------------------------------------------------------------- */

int rc_intersect( GRECT *r1, GRECT *r2 )
{
   int x, y, w, h;

   x = max( r2->g_x, r1->g_x );
   y = max( r2->g_y, r1->g_y );
   w = min( r2->g_x + r2->g_w, r1->g_x + r1->g_w );
   h = min( r2->g_y + r2->g_h, r1->g_y + r1->g_h );

   r2->g_x = x;
   r2->g_y = y;
   r2->g_w = w - x;
   r2->g_h = h - y;

   return ( ((w > x) && (h > y) ) );
}



/* ---------------------------------------------------------- */
/*       void redraw_window( int all );                       */
/* ---------------------------------------------------------- */

void redraw_window( int all )
{
GRECT     box,work;
int       clip[4];

wind_update( BEG_UPDATE );
hidem;
vsf_color( handle, 1 );                       /* set fill */
vswr_mode( handle, 1 );                       /* set replace mode */

wind_get( whandle, WF_WORKXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h );
wind_get( whandle, WF_FIRSTXYWH, &box.g_x, &box.g_y, &box.g_w, &box.g_h );

while( box.g_w > 0 && box.g_h > 0 )
{
    if( rc_intersect( &work, &box ) )
    {
       clip[0] = box.g_x;
       clip[1] = box.g_y;
       clip[2] = box.g_x + box.g_w - 1;
       clip[3] = box.g_y + box.g_h - 1;
       vs_clip( handle, 1, clip );
       if( all )
          vr_recfl( handle, clip );     /* fill rectangle */
/*            v_gtext( handle, (work.g_x + work.g_w / 2) 
                - (int)strlen( s ) * gl_wchar / 2,
                work.g_y + ym / 10, s );
*/    }
    wind_get( whandle, WF_NEXTXYWH, &box.g_x, &box.g_y, &box.g_w, &box.g_h );
} /* next rectangle */
showm;
wind_update( END_UPDATE );
} /* redraw_window() */



/* ---------------------------------------------------------- */
/*       int handle_message( int mbuf[8] )                    */
/* ---------------------------------------------------------- */

int handle_message( int mbuf[8] )
{
   switch ( mbuf[0] )
   {
      case WM_REDRAW:
         redraw_window( 1 );
      break;

      case WM_TOPPED:
         wind_set( whandle, WF_TOP );
      break;

      case WM_CLOSED:
         if ( mbuf[3] == whandle )
         {
            wind_close( whandle );
            wind_delete( whandle );
            whandle = 0;
         }
         if ( _app )
            return( 1 );
      break;

      case WM_MOVED:
      case WM_SIZED:
         if ( mbuf[3] == whandle )
            wind_set( whandle, WF_CURRXYWH,  mbuf[4], mbuf[5], mbuf[6], mbuf[7] );
     break;

      case AC_OPEN:
         if ( mbuf[4] == menu_id )
            open_window( );
      break;

      case AC_CLOSE:
         if ( mbuf[3] == menu_id )
            whandle = 0;
      break;
   }
   return 0;
}



/* ---------------------------------------------------------- */
/*    event_loop()                                            */
/*                                                            */
/*    Die Multi-Event-Schleife.                               */
/* ---------------------------------------------------------- */

void event_loop( void )
{
   int x, y,
       kstate,
       key,
       clicks,
       event,
       state;
   int mbuf[8];
   int quit;

   quit = 0;
   do
   {
      pf("\r\x1Bk\x1Bv Enter command: \r");
      event = evnt_multi( MU_MESAG|MU_KEYBD,
                          2, 0x1, 1,
                          0, 0, 0, 0, 0,
                          0, 0, 0, 0, 0,
                          mbuf,
                          1000, 0,
                          &x, &y, &state, &kstate, &key, &clicks );
      pf("\r                     \r");

      wind_update( BEG_UPDATE );

/* ########################################################## */
/*               Here call your specific routines             */
/* ########################################################## */

      if ( event & MU_MESAG ) {
		quit = handle_message(mbuf);
	 }

	if ( event & MU_KEYBD ) {
		switch(key & 0xFF) {
			case 'a':
				read_font("C:\\FONTS\\SHSS23.FNT",0);
				text_color(LYELLOW);
				gprint("ABCDEabcde12345", 44, 44);
				create_afont(0);
				text_color(0xFFE0);
				aprint("ABCDEabcde12345", 44, 88);
				delete_font(0);
			break;
			case 'b':
				g_color(0x7E0);
				xy[0]=39; xy[1]=39; xy[2]=299; xy[3]=39;
				xy[4]=9; xy[5]=179; xy[6]=199; xy[7]=199;
				bezier(xy);
			break;
			case 'f':
				read_font("C:\\FONTS\\SHSS48.FNT",0);
				read_font("C:\\FONTS\\SHSS14.FNT",1);
				read_font("C:\\FONTS\\SHRK17.FNT",2);

				text_font(2);
				text_color(BLUE);
				gprint("ABCDEabcde12345", 444, 88);
				text_color(MAGENTA);
				gprint("ABCDEabcde12345", 44, 55);

				text_font(1);
				text_color(LCYAN);
				gprint("ABCDEabcde12345", 199, 99);
				text_color(WHITE);
				gprint("* You can load and print standard GEM fonts without GDOS", 111, 222);
				gprint("* using this feature is very easy with three new commands", 111, 244);
				gprint("* two other commands set text colour and font", 111, 266);
				gprint("* in TRUE COLOUR mode on Falcon are available antialiased fonts", 111, 288);

				text_font(0);
				text_color(RED);
				gprint(" Excellent!!! ", 122, 144);
				text_color(YELLOW);
				gprint(" Need fonts? It's easy! ", 11, 333);

				delete_font(0);
				delete_font(1);
				delete_font(2);
			break;
			case 'l': g_color(0xF01F); aline(0,0,299,39); break;
			case 'm': measure_pixel(); break;
			case 'o': load(); break;
			case 'p': show_palette(2,50); break;
			case 's': play_seq(); break;
			case 't': {	/* TC graphic */
				IMAGE im=NIMAGE;
				im.width=318; im.height=196;  im.colours=0x10000;
				alloc_map(&im);
				shaded_box(0xF000,0xFF,0,&im);
				show_image(0,0,im.width,im.height,1,44,&im);
				delete_image(&im);

				im.width=144; im.height=99;  im.colours=0x10000;
				alloc_map(&im);
				shaded_box(0x0,0xFFFF,0,&im);
				show_image(0,0,im.width,im.height,44,66,&im);
				shaded_box(0x0400,0xFF00,0,&im);
				show_image(0,0,im.width,im.height,111,99,&im);
				delete_image(&im);
			} break;
			case 'q': quit=1; break;

		} /* switch(key) */
	} /* if(event & MU_KEYBD) */

/* ########################################################## */
/* ########################################################## */

      wind_update( END_UPDATE );
   }
   while ( !quit );
}



/* ---------------------------------------------------------- */
/*                        USER ROUTINES                       */
/* ---------------------------------------------------------- */


/*** shows image parameters ***/
void show_params(IMAGE *im)
{
	static char window_title[80];

	sprintf(window_title,"Image * w,h: %i,%i * col:%li",
		im->width, im->height, im->colours);
	wind_set(whandle,WF_NAME,window_title);
}



/*** user program initialization ***/
void my_init(void)
{
	atexit(end);
	save_palette();
	true_colour(0);	/* 1 -> TC mode ON */
}



/*** this procedure is executed at end of program ***/
void end(void)
{
	true_colour(0);
	restore_palette();
}



/*** SEQ animation replay ***/
void play_seq(void)
{
int error;
IMAGE i,old_screen;

old_screen = NIMAGE;
old_screen.colour_map = rgb_old;  old_screen.colours = cm;
fade_out(handle,&old_screen);

error = read_seq(0,0,-1,"DOG.SEQ",&i);
if(error==-39) {
	fprintf(stderr,"No memory for animation replay\n");
	return;
}
if(error) {
	fprintf(stderr,"Bad or missing DOG.SEQ file\n");
	return;
}

/***
error = write_img(0,0,i.width,i.height,"XX.IMG",&i);
show_params(&i);  evnt_keybd();
***/

fade_out(handle,&i);  fade_in(handle,&old_screen);

delete_image(&i);

} /* play_seq() */



/*** read & show picture ***/
void load(void)
{
char str[99];
int error,jj,l,xpos=22,ypos=44;
IMAGE i;

/**
error=read_ca("TEST.CA1",&i);
error=read_gif("TEST.GIF",&i);
error=read_img("TEST.IMG",&i);
error=read_iff("TEST.IFF",&i);
error=read_tga("TEST.TGA",&i);
error=write_tga("XX.TGA",&i);
error=read_raw(320,240,16,"SCREEN.RAW",&i);
show_image(0,0,i.width,i.height,32,55,&i);
**/

error=read_ca("TEST.CA1",&i);
if(error==-39) {
	fprintf(stderr,">>> No memory for picture\n");
	return;
}
if(error) {
	fprintf(stderr,">>> Bad or missing file\n");
	return;
}

nat2spec(&i);
set_palette(handle,&i);
show_params(&i);
show_image(0,0,i.width,i.height,xpos,ypos,&i);

show_palette(222,60);

/* test joystick routines */
/***
stick_on();
while( ! (stick(1)&0xF) ) ;
do {
	jj = stick(1);
	printf("\r joy %4X",jj);
	printf(" : jjj %2X%2X%2X%2X",jstate[0],jstate[1],jstate[2],jstate[3]);
	printf(" : key %2X%2X%2X%2X",kstate[0],kstate[1],kstate[2],kstate[3]);
	if(jj&8)
		xpos += 8;
	else if(jj&4)
		xpos -= 8;
	if(jj&2)
		ypos += 8;
	else if(jj&1)
		ypos -= 8;
	show_image(0,0,126,77,xpos,ypos,&i);
} while( !(jj&0x80) );
stick_off();
***/

/***
error=write_img(0,0,i.width,i.height,"XX.IMG",&i);
delete_image(&i);
error=read_img("XX.IMG",&i);
set_palette(handle,&i);
show_params(&i);
show_image(0,0,i.width/4,i.height/2,302,166,&i);
***/

delete_image(&i);

} /* load() */
